;$(function(){

	var video_auto_id = 0;
	var playingVideo = null;

	function keepOnlyOneVideoPlaying(obj){
		if (playingVideo) {
			pause(playingVideo);
		}
		playingVideo = obj;
	}

 	function fullScreen(e){
		var collection = e.data;

		collection.controlBar.fadeOut("fast",function(){
			collection.isShowControlBar = false;
		});
		if (collection.videoElement.webkitEnterFullScreen) {
			collection.videoElement.webkitEnterFullScreen();
		}
		e.stopPropagation();
	};

	function play(e){
		var collection = e.data;

		keepOnlyOneVideoPlaying(collection);
 		collection.wifiState.hide();
 		if (collection.firstPlay) {
 			collection.wifiStateSpan.hide();
 			collection.isShowControlBar = true;
 			hideControlBar(collection);
 			collection.firstPlay = false;
 		}else{collection.isShowControlBar = false;}
 		collection.videoElement.play();
 		e.stopPropagation();
 	}

	function hideControlBar(obj){
		if (obj.timer) { clearTimeout(obj.timer);}
		obj.timer = setTimeout(function(){
			obj.controlBar.fadeOut("normal",function(){
				obj.isShowControlBar = false;
			});
		},3000);
	}

	function pause(e){
		var trueEvent = e.data;
		var collection = trueEvent ? trueEvent : e;

 		collection.controlBar.fadeOut("fast");
 		collection.isShowControlBar = false;
		collection.wifiState.show();
		collection.videoElement.pause();
		if (trueEvent) {
			e.stopPropagation();
		}
	};

	function loadeddata(){
		console.log(aib);
		alert(aib);
		aib.runClientMethod("webViewHeight",document.body.scrollHeight);
	}

 	function videoTap(e){
 		var collection = e.data;

 		if (collection.isShowControlBar) {
			collection.controlBar.fadeOut("normal",function(){
				collection.isShowControlBar = false;
			});
 		}else{
 			collection.controlBar.fadeIn(100,function(){
 				hideControlBar(collection);
 				collection.isShowControlBar = true;
 			});
 		}
		e.stopPropagation();

 	};

 	function videoEndedListener(e){
 		playingVideo = null;
 		var collection = e.data;

 		collection.wifiState.show();
 		collection.isShowControlBar = false;
 		collection.videoElement.pause();
 		stopTrackingPlayProgress(collection);
	}

	function playListener(e){
 		trackPlayProgress(e.data);
 	};

 	function pauseListener(e){
		stopTrackingPlayProgress(e.data);
 	};

	function videoTime(e){
		var collection = e.data;
		var totolTime = stom(collection.videoElement.duration);
		collection.videoTime.html(totolTime);
		collection.wifiStateSpan[0].innerHTML=totolTime;
     };
   
 	function stom(t){
		var m = Math.floor(t/60);
		m < 10 && (m = '0' + m);
		return m + ":" + (t%60/100).toFixed(2).slice(-2);
	}

 	function updatePlayProgress(obj){
 		var currentPos = obj.videoElement.currentTime;
 		var precentTime = currentPos/obj.videoElement.duration;
    	obj.videoCurrentTime.html(stom(currentPos));
 		obj.proBar.css("width",precentTime*(obj.proHolder.width()-4.5));
 		obj.proPoint.css("left",precentTime*(obj.proHolder.width()-4.5));
 	}

 	function trackPlayProgress(obj){ 
		(function proTrack() { 
			updatePlayProgress(obj);
			obj.processTimer = setTimeout(proTrack, 50); 
		})(); 
	}

	function stopTrackingPlayProgress(obj){ 
		clearTimeout(obj.processTimer);
	}

	function touchstartListener(e) {
		var collection = e.data;

        collection.startPositionX = e.touches[0].pageX;
        collection.startPositionY = e.touches[0].pageY;
        collection.touchStartVideoTime = collection.videoElement.currentTime;
    }

    function touchendListener(e) {
		var collection = e.data;
		console.log(e.changedTouches[0].pageY - collection.startPositionY);
    	var scale = (e.changedTouches[0].pageX - collection.startPositionX)/collection.videoElement.clientWidth;
    	if (scale > 0.01 || scale < -0.01) {
    		collection.videoElement.currentTime = collection.touchStartVideoTime + scale*0.25*collection.videoElement.duration;
    	}
    }

	function aib_video(obj){

		var videoBoxIdString = "aib_video_" + video_auto_id;
		var videoBoxId = "#" + videoBoxIdString;
		var sizeKb = obj.size/(1000*8);
		var size = (sizeKb > 1000) ? (sizeKb/1000).toFixed(2)+"M" : sizeKb.toFixed(2)+"KB";
		$(obj.flagString).append('<div class=\"videoBox\" id=\"' + videoBoxIdString + '\">\
									<video webkit-playsinline playsinline preload=\"auto\" poster=\"'+obj.poster+'\">\
										<source src=\"'+obj.url+'\">\
									</video>\
									<div class=\"controlBar\">\
										<img src=\"\" class=\"videoButton\" id=\"pause\">\
										<div class=\"videoButton\" id=\"progress\">\
											<span class=\"curTime\">00:00</span>\
											<div id=\"progress_box\">\
												<span id=\"play_progress\"></span>\
												<span id=\"play_progress2\"></span>\
											</div>\
											<span class=\"sumTime\">00:00</span>\
										</div>\
										<img class=\"videoButton\" id=\"fullScreen\" src=\"\">\
									</div>\
									<div class=\"wifiState\">\
										<div>\
											<img src=\"./play.png\" id=\"play\">\
											<span id=\"videoTime\"></span>\
											<span id=\"videoNotice\">本视频需要'+size+'流量</span>\
										</div>\
									</div>\
								</div>');
		
		var videoInfo = {
			videoElement: $(videoBoxId + " video")[0],
			isShowControlBar: false,
			firstPlay : true,
			wifiState : $(videoBoxId + " .wifiState"),
			wifiStateSpan: $(videoBoxId + " .wifiState span"),
			controlBar: $(videoBoxId + " .controlBar"),
			controlBartimer : null,

			videoTime: $(videoBoxId + " .sumTime"),
			videoCurrentTime: $(videoBoxId + " .curTime"),
			proHolder : $(videoBoxId + " #progress_box"),
			proBar : $(videoBoxId + " #play_progress"),
			proPoint : $(videoBoxId + " #play_progress2"),
			processTimer: null,

			startPositionX : 0,
			startPositionY : 0,
			touchStartVideoTime : 0,

		};
		videoInfo.wifiState.css("background-image","url("+ obj.poster +")");
		var videoZepto = $(videoBoxId + " video");

		$(videoBoxId + ' #fullScreen').on('tap',videoInfo,fullScreen);
		$(videoBoxId + ' .wifiState #play').on('click',videoInfo,play);
		$(videoBoxId + ' #pause').on('tap',videoInfo,pause);
		videoZepto.on('tap',videoInfo,videoTap);
		videoZepto.on('ended',videoInfo,videoEndedListener); 
		videoZepto.on('play',videoInfo,playListener);
		videoZepto.on('pause',videoInfo,pauseListener);
		videoZepto.on('loadedmetadata',videoInfo,videoTime);
		videoZepto.on('loadeddata',loadeddata);

		video_auto_id++;
	}

	window.aib_video = aib_video;
});
